/**
 * The Class TestObjectList is used to test classes ObjectList, Shape, Circle
 * and Rectangle
 * 
 * @author Silvia Santini, bcyrill
 * Informatik II - SS2007, 
 * Uebungsserie 6, 
 * Aufgaben 2/3,
 */
class TestObjectList {

	public static void main(String[] args) {

		ObjectList objlist1 = new ObjectList();

		try {
			// create a list of generic objects
			objlist1.addFirst(new String("Soup Bowl"));
			objlist1.addFirst(new Character('B'));
			objlist1.addFirst(new Integer(1));
			objlist1.addFirst(new Boolean(true));
			objlist1.addFirst(new Short((short) 2008));

			// EXERCISE 2b
			// print the list created above using the toString() method
			System.out.println(" Test for exercise 2b:");
			System.out.println(objlist1);
			System.out.println();

			// EXERCISE 2c
			// print the list using the toVerboseString() method
			System.out.println(" Test for exercise 2c:");
			System.out.println(objlist1.toVerboseString());
			System.out.println();

			// ADDITIONAL TESTS
			// create a second list
			ObjectList objlist2 = new ObjectList();
			objlist2.addFirst(new Boolean(false));
			// add some other elements to this list
			objlist2.addFirst(new Character('y'));
			objlist2.addRandomElements(3);
			objlist2.addFirst(new Boolean(true));
			objlist2.addFirst(new Integer(13));
			objlist2.addFirst(new String("Googolplex"));

			// add this second list to the top of the first one
			objlist1.addFirst(objlist2);
			// then print the obtained list in both non verbose and verbose mode
			// print the list in non verbose mode
			System.out.println(" Concatenated lists, non verbose mode:");
			System.out.println(objlist1);
			System.out.println(" Concatenated lists, verbose mode:");
			System.out.println(objlist1.toVerboseString());
			System.out.println();

			// EXERCISE 3c
			// create a new list
			ObjectList objlist3 = new ObjectList();

			// add Character elements to the new list
			char[] myChars = "Barbados".toCharArray();
			for (int i = myChars.length - 1; i >= 0; i--) {
				objlist3.addFirst(new Character(myChars[i]));
			}

			// sort the list objlist3 and
			// print both the unsorted and sorted list
			System.out.println(" Unsorted list:");
			System.out.println(objlist3);
			objlist3.sortSelf();
			System.out.println(" Sorted list:");
			System.out.println(objlist3);
			System.out.println();

			// EXERCISE 3d
			ObjectList objlist4 = new ObjectList();
			// create a list of 5 circles with random radii
			objlist4.addFirst(new Circle(22));
			objlist4.addFirst(new Circle(130));
			objlist4.addFirst(new Circle(42));
			objlist4.addFirst(new Circle(88));
			objlist4.addFirst(new Circle(4));

			// and print both the unsorted and sorted lists
			System.out.println(" Unsorted circle list:");
			System.out.println(objlist4);
			objlist4.sortSelf();
			System.out.println(" Sorted circle list:");
			System.out.println(objlist4);
			System.out.println();

			// EXERCISE 3e
			// add a Rectangle element to the list objlist4
			// sort the list objlist 4
			// and print both the sorted and unsorted lists
			objlist4.addFirst(new Rectangle(12, 24));
			System.out.println(" Unsorted area list:");
			System.out.println(objlist4);
			objlist4.sortSelf();
			System.out.println(" Sorted area list:");
			System.out.println(objlist4);
			System.out.println();

		} catch (Exception e) {
			e.printStackTrace();
		}
	} // end main()

} // end class TestObjectList

